(function () {
    angular.module('starter.controllers', [])
        .controller('MainCtrl', ['$ionicLoading', '$ionicScrollDelegate', '$window', '$scope', 'Feed', '$ionicModal', '$sce', '$state', function ($ionicLoading, $ionicScrollDelegate, $window, $scope, Feed, $ionicModal, $sce, $state) {

            if (typeof analytics !== 'undefined') {
                analytics.trackView("Controller.js - Tracking the Google Analytics");
            }

            if (!Feed.start) {
                Feed.loadStartFeed();
            }
            console.log('start', Feed.start);
            $scope.$on('feeds.update', function () {
                $scope.feeds = Feed.feeds;
            });

            $scope.doRefresh = function () {
                Feed.loadNewFeed();
                $ionicLoading.show({
                    template: "Loading..."
                });
            };

            $scope.loadMore = function () {
                $ionicLoading.show({
                    template: "Loading..."
                });

                Feed.loadOldFeed();

            };


            //open url for original post
            $scope.openUrl = function () {
                window.open($scope.feedDetail.link, '_system', 'location=yes');
            };


            // trust src for video
            $scope.trustSrc = function (src) {
                return $sce.trustAsResourceUrl(src);
            };

            //modal
            $ionicModal.fromTemplateUrl('templates/feed.html', {
                scope: $scope,
                animation: 'slide-in-right'
            }).then(function (modal) {
                $scope.modalFeed = modal;
            });
            $scope.openModal = function ($index) {
                $scope.feedDetail = Feed.feeds[$index];
                $scope.modalFeed.show();
            };
            $scope.closeModal = function () {
                $scope.modalFeed.hide();
            };
            //Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function () {
                $scope.modalFeed.remove();
            });
            // Execute action on hide modal
            $scope.$on('modal.hidden', function () {
                // Execute action
                $scope.feedDetail = {};
            });

            //about me modal
            $ionicModal.fromTemplateUrl('templates/about.html', {
                scope: $scope,
                animation: 'slide-in-right'
            }).then(function (modal) {
                $scope.modalAbout = modal;
            });
            $scope.openModalAbout = function () {
                $scope.modalAbout.show();
            };
            $scope.closeModalAbout = function () {
                $scope.modalAbout.hide();
            };
            //Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function () {
                $scope.modalAbout.remove();
            });

        }])

})();
