/**
 * Created by HKMCI on 2/10/2014.
 */
(function () {
    'use strict';
    angular.module('starter.services', ['ngResource'])
        .factory('Feeds', ['$resource', function ($resource) {
            return $resource('http://mobile-api-lb-1668020713.ap-northeast-1.elb.amazonaws.com/soanalytics/app/ProfileAnalysisService/:feedType/saapp2014?dateStr=:dateStr&feedId=:feedParams', {}, {
                query: {method: 'GET', params: {}, isArray: false},
                queryup: {method: 'GET', params: {}, isArray: false},
                querydown: {method: 'GET', params: {}, isArray: false}
            });
        }])
        .factory('Feed', ['$rootScope', 'Feeds', '$ionicLoading', '$ionicScrollDelegate', function ($rootScope, Feeds, $ionicLoading, $ionicScrollDelegate) {
            var service = {};
            service.start = false;
            service.detail = [];
            service.feeds = [];
            service.feedid = ['', ''];
            service.dateStr = ['', ''];
            service.loading = false;

            service.getDetail = function (id) {
                if (!service.loading) {
                    service.detail = service.feeds[id];
                }
            };

            service.loadStartFeed = function () {
                service.loading = true;
                console.log('start', service.loading);
                var startFeed = Feeds.query({feedType: 'getStartFeed', dateStr: '', feedParams: ''});
                startFeed.$promise.then(function (res) {
                    service.feeds = res.result.feedList;
                    service.feedid[0] = res.result.feedList[0].feedId;
                    service.feedid[1] = res.result.feedList[9].feedId;
                    service.dateStr[0] = res.result.feedList[0].pDate;
                    service.dateStr[1] = res.result.feedList[9].pDate;

                    $rootScope.$broadcast('feeds.update');
                    //setTimeout(function(){service.start = true},1000);
                    service.loading = false;
                    console.log('start done', service.loading);
                });


            };

            service.loadNewFeed = function () {

                if (!service.loading) {
                    service.loading = true;
                    console.log('load new', service.loading);


                    var newFeeds = Feeds.queryup({feedType: 'getNewFeed', dateStr: service.dateStr[0], feedParams: service.feedid[0]}); // API for newFeed
                    newFeeds.$promise.then(function (res) {
                        console.log('total rec', res.totalRecord);
                        if (res.totalRecord != 0) { //in case of no new feeds

                            service.feeds.unshift.apply(service.feeds, res.result.feedList);
                            console.log(service.feeds.length);// put new feeds in the beginning of feed list
                            if (service.feeds.length >= 40) {
                                service.feeds = service.feeds.slice(0, 40);
                                console.log(service.feeds.length);
                            }

                            service.feedid[0] = service.feeds[0].feedId;
                            service.feedid[1] = service.feeds[service.feeds.length - 1].feedId;
                            service.dateStr[0] = service.feeds[0].pDate;
                            service.dateStr[1] = service.feeds[service.feeds.length - 1].pDate;

                        }
                        console.log('new feedid', service.feedid, 'datestr', service.dateStr);
                        service.loading = false;
                        $rootScope.$broadcast('scroll.refreshComplete');
                        $rootScope.$broadcast('feeds.update');
                        console.log('load new done', service.loading);
                        $ionicLoading.hide();
                    });

                } else {
                    $rootScope.$broadcast('scroll.refreshComplete');
                    $ionicLoading.hide();

                }

            };

            service.loadOldFeed = function () {
                //if (!service.loading && service.start) {
                if (!service.loading) {

                    //$ionicScrollDelegate.scrollBy(0, -50);
                    service.loading = true;
                    console.log('load old', service.loading);

                    console.log("old", service.feedid[1], ' date', service.dateStr[1]);

                    var oldFeeds = Feeds.querydown({feedType: 'getOldFeed', dateStr: service.dateStr[1], feedParams: service.feedid[1]}); //API for oldFeed
                    oldFeeds.$promise.then(function (res) { //data = feedlist
                        //$ionicScrollDelegate.scrollTo(0,0); //
                        

                        service.feeds.push.apply(service.feeds, res.result.feedList);// put new feeds in the end of feed list
                        

                        $rootScope.$broadcast('scroll.infiniteScrollComplete');
                        $rootScope.$broadcast('scroll.resize');
                       
                        var testHeight=0;
                        var atestHeight=0;
                        
                        for(var i=0; i < $('.item').length; i++){
                           atestHeight = atestHeight+$('.item').eq(i).height();
                        }
                       
                        $rootScope.$broadcast('feeds.update');
                         $ionicScrollDelegate.resize();
                        
                        console.log(service.feeds.length);
                        if (service.feeds.length >= 40) {
                        	   for(var i=0; i < service.feeds.length - 40; i++){
                                 testHeight = testHeight+$('.item').eq(i).height();
                             }
                             
                             service.feeds = service.feeds.slice(service.feeds.length - 40, service.feeds.length);
                             $ionicScrollDelegate.scrollTo(0, atestHeight-testHeight, false);
                             $rootScope.$broadcast('feeds.update');
                             console.log(service.feeds.length);

                        }

                        service.feedid[0] = service.feeds[0].feedId;
                        service.feedid[1] = service.feeds[service.feeds.length - 1].feedId;
                        service.dateStr[0] = service.feeds[0].pDate;
                        service.dateStr[1] = service.feeds[service.feeds.length - 1].pDate;
                        
                        service.loading = false;
                        console.log('load old done', service.loading);
                        console.log('old feedid', service.feedid, 'datestr', service.dateStr);
                        setTimeout(function(){$ionicLoading.hide()},300);
                        //$ionicScrollDelegate.scrollTo(0, 0);
                    });

                } else {
                    $rootScope.$broadcast('scroll.infiniteScrollComplete');
                    $rootScope.$broadcast('scroll.resize');
                    $ionicLoading.hide();
                }
            };
            return service;
        }]);
})();


